/****************************************************************************/
/**    GNOM - Gnom is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Funktionen frs Log                                                   **/
/****************************************************************************/

#include "global.h"

#include "toolbox.h"

static char month[12][4]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

static char header[]    = "      Port     Starttime       Endtime        rxB   txB  Mycall        ConnPath\xA\xA";

/* Schreibt ber diese Verbindung einen Eintrag ins Logbuch. Als disconnect-
 * Zeit wird der aktuelle Zeitpunkt genommen, also nur aufrufen, wenn auch wirklich
 * disconnected werden soll.
 */
void log_connection(int chan)
{
  char tmp[500],filename[500];
  struct tm *stime,*etime;
  time_t akttime;
  int fd,write_header=FALSE;
  
  
  /* Starttime & Endtime */
  stime = gmtime(&chaninfo[chan]->logintime);
  akttime = time(NULL);
  etime = gmtime(&akttime);
  
  
  /* Die Zeile, die in das logfile geschrieben werden soll, erzeugen */
  if (chaninfo[chan]->digis != NULL)
     sprintf(tmp,"%10s  %.2i.%.2i.%.2i %.2i:%.2i  %.2i.%.2i.%.2i %.2i:%.2i  %5li %5li  %s <-> %s %s\xA",
                 chaninfo[chan]->port,
                 stime->tm_mday,stime->tm_mon+2,stime->tm_year,stime->tm_hour,stime->tm_min,
                 etime->tm_mday,etime->tm_mon+2,etime->tm_year,etime->tm_hour,etime->tm_min,
                 chaninfo[chan]->rx_bytes,chaninfo[chan]->tx_bytes,
                 chaninfo[chan]->mycall,
                 chaninfo[chan]->firstcall,chaninfo[chan]->digis);
  else
     sprintf(tmp,"%10s  %.2i.%.2i.%.2i %.2i:%.2i  %.2i.%.2i.%.2i %.2i:%.2i  %5li %5li  %s <-> %s\xA",
                 chaninfo[chan]->port,
                 stime->tm_mday,stime->tm_mon+2,stime->tm_year,stime->tm_hour,stime->tm_min,
                 etime->tm_mday,etime->tm_mon+2,etime->tm_year,etime->tm_hour,etime->tm_min,
                 chaninfo[chan]->rx_bytes,chaninfo[chan]->tx_bytes,
                 chaninfo[chan]->mycall,
                 chaninfo[chan]->firstcall);
  
  
  sprintf(filename,"%s/log/%s%i.log",config->maindir,month[etime->tm_mon],etime->tm_year+1900);
  
  if (!file_exist(filename)) write_header = TRUE;
  if ((fd = open(filename,O_WRONLY|O_CREAT|O_APPEND)) == -1)
  {
    syslog(LOG_ERR,"Unable to create the logfile (%s)!",filename);
    return;
  }
  
  if (write_header)
  {
    write(fd,header,sizeof(header)-1);
    
    /* Zugriffsrechte einstellen */
    fchmod(fd,S_IRUSR|S_IWUSR);
  }
  write(fd,tmp,strlen(tmp));
  
  close(fd);
  
}


